-- Author      : Gudvinus
local EVENT, DB = {},{};
local l,tempID;

local After							= C_Timer.After;
local ApplyToGroup					= C_LFGList.ApplyToGroup;
local GetApplicationInfo			= C_LFGList.GetApplicationInfo;
local GetAvailableRoles				= C_LFGList.GetAvailableRoles;
local GetSearchResultInfo			= C_LFGList.GetSearchResultInfo;
local GetSearchResults				= C_LFGList.GetSearchResults;
local IsInGroup						= IsInGroup;
local IsQuestFlaggedCompleted		= IsQuestFlaggedCompleted;
local LFGListInviteDialog_Accept	= LFGListInviteDialog_Accept;
local find							= find;
local lower							= string.lower;
local pairs							= pairs;
local strsplit						= strsplit;
local format						= string.format;

local DP={["Toy"]={true,true,"dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник","camp||farm||not up",false,3,4,false,0},["Opasik"]={true,true,"terr||doom||death||veng","camp||farm||not up",true,3,4,false,0}};


local ACHIEVEMENT_COLOR_CODE		= "|cffffff00";
local BATTLENET_COLOR	= "|cff82c5ff";
local DISABLED_FONT_COLOR_CODE	= "|cff7f7f7f";
local FONT_COLOR_CODE_CLOSE		= "|r";
local GRAY_FONT_COLOR_CODE		= "|cff808080";
local GREEN_COLOR		= "|cff20ff20";
local HIGHLIGHT_FONT_COLOR_CODE	= "|cffffffff";
local LIGHTYELLOW_FONT_COLOR_CODE	= "|cffffff9a";
local NORMAL_FONT_COLOR_CODE		= "|cffffd200";
local ORANGE_COLOR		= "|cffff7f3f";
local RED_COLOR			= "|cffff2020";
local YELLOW_COLOR		= "|cffffff00";
local EMPTY				= ""

local L = {
	ruRU = {
		REFRESHRATE = "Частота обновления",
		REFRESHRATEHELP = "Если сервер вернет ошибку частота запросов автоматически будет понижаться.",
		AGEMAKEGROUP = "Время с создания группы",
		AGEMAKEGROUPHELP = "Максимальное время прошедшее с момента создания группы,\nпосле которого группа будет игнорироваться.",
		AGEMAKEGROUPHELPWARN = "[0 Без ограничений]",
		STRINGFIND = "Ключевые слова",
		STRINGFINDHELP = "Вводите в это поле слова или словосочетания, разделяя их символом ||",
		STRINGFINDHELPWARN = "Поле не может быть пустым!",
		STRINGEXCLUDE = "Без слов",
		STRINGEXCLUDEHELP = "Вводите в это поле слова или словосочетания, разделяя их символом |\nЕсли слово будет найдено в названии группы, то эта группа будет игнорироваться.",
		STRINGEXCLUDEHELPWARN = "Поле может быть пустым!",
		AUTOINV = "Принимать приглашения",
		AUTOINVHELP = "Автоматически подтверждать присоединение к группе.",
		AUTOINVHELPWARN = "",
		AUTOINVGROUP = "Группы с автоинвайтом",
		AUTOINVGROUPHELP = "Искать группы только с автоинвайтом.",
		AUTOINVGROUPHELPWARN = "",
		TESTMODETOOLTIP = "Режим тестирования",
		TESTMODETOOLTIPHELP = "Тестирование ключевых слов и настроек, выводит сообщения, но не присоединяется к группе.",
		TESTMODETOOLTIPHELPWARN = "",
		MINPLAYERS = "Минимум игроков",
		MINPLAYERSHELP = "Минимальное количество игроков в группе, меньше которого группа будет игнорироваться.",
		MINPLAYERSHELPWARN = "[0 Без ограничений]",
		CROSSREALMMODE = "Межсерверный режим",
		CROSSREALMMODEHELP = "",
		CROSSREALMMODEHELPWARN = "В связи с изменениями механики переходов, этот режим пока не эффективен!!!",
		HELPTOOLTIP = "Помощь",
		HELPTOOLTIPHELP1 = "Shift+Левый клик по окну:",
		HELPTOOLTIPHELP2 = "перемещение окна.",
		HELPTOOLTIPHELP3 = "Левый клик:",
		HELPTOOLTIPHELP4 = "Показать/Спрятать подсказки.",
		HELPTOOLTIPHELPWARN = "",
		GUDSFGBUTTONTOOLTIP1 = "Левый клик:",
		GUDSFGBUTTONTOOLTIP2 = "поиск старт/стоп.",
		GUDSFGBUTTONTOOLTIP3 = "Правый клик:",
		GUDSFGBUTTONTOOLTIP4 = "показать/скрыть главное окно.",
		GUDSFGBUTTONTOOLTIP5 = "Средний клик:",
		GUDSFGBUTTONTOOLTIP6 = "управление профилями.",
		GUDSFGBUTTONTOOLTIP7 = "Shift+Левый клик:",
		GUDSFGBUTTONTOOLTIP8 = "перемещение кнопки.",
		STATUS = "Статус: %s",
		NOKEYWORD = "Нет ключевых слов!",
		INGROUP = "Вы в группе, поиск остановлен!",
		FINDSTOP = "Поиск группы остановлен.|r",
		GROUPCOUNT = "Кол-во групп в поиске: %s",
		PROFILES = "Профили",
		PROFILELOADED = "SGF: Профиль: %s загружен.",
		PROFILESAVE = "SGF: Профиль: %s сохранен.",
		PROFILEDELETE = "SGF: Профиль: %s удален.",
		PROFILELOAD = "Загрузить",
		WARNDELPROFILE = "Чтобы удалить профиль удерживайте клавишу Shift!",
	},
	enGB = {
		REFRESHRATE = "Refresh rate",
		REFRESHRATEHELP = "If the server returns an error, the request rate will automatically decrease.",
		AGEMAKEGROUP = "Time of group creation",
		AGEMAKEGROUPHELP = "The maximum time elapsed since the creation of the group,\n after which the group will be ignored.",
		AGEMAKEGROUPHELPWARN = "[0 Without restrictions]",
		STRINGFIND = "Keywords",
		STRINGFINDHELP = "Enter into this box word or phrase, separated by the |character",
		STRINGFINDHELPWARN = "Field can't be empty!",
		STRINGEXCLUDE = "Without words",
		STRINGEXCLUDEHELP = "Enter into this box word or phrase, separated by a |character.\nIf the word is found in the name of the group, this group will be ignored.",
		STRINGEXCLUDEHELPWARN = "Field may be empty!",
		AUTOINV = "Accept invitations",
		AUTOINVHELP = "Automatically approve joining the group.",
		AUTOINVHELPWARN = "",
		AUTOINVGROUP = "Group autoinvite",
		AUTOINVGROUPHELP = "Look for a group only with autoinvite.",
		AUTOINVGROUPHELPWARN = "",
		TESTMODETOOLTIP = "Test mode",
		TESTMODETOOLTIPHELP = "Testing of keywords and settings and displays messages, but does not join the group.",
		TESTMODETOOLTIPHELPWARN = "",
		MINPLAYERS = "Minimum players",
		MINPLAYERSHELP = "The minimum number of players in the group, a smaller group will be ignored.",
		MINPLAYERSHELPWARN = "[0 Without restrictions]",
		CROSSREALMMODE = "Cross Realm Mode",
		CROSSREALMMODEHELP = "",
		CROSSREALMMODEHELPWARN = "In connection with changes in the mechanics of navigation, this mode is not efficient!!!",
		HELPTOOLTIP = "Help",
		HELPTOOLTIPHELP1 = "Shift+Left-click on the window:",
		HELPTOOLTIPHELP2 = "the movement of the window.",
		HELPTOOLTIPHELP3 = "Left-click:",
		HELPTOOLTIPHELP4 = "Show/Hide tips.",
		HELPTOOLTIPHELPWARN = "",
		GUDSFGBUTTONTOOLTIP1 = "Left-click:",
		GUDSFGBUTTONTOOLTIP2 = "search start/stop.",
		GUDSFGBUTTONTOOLTIP3 = "Right-click:",
		GUDSFGBUTTONTOOLTIP4 = "show/hide the main window.",
		GUDSFGBUTTONTOOLTIP5 = "Middle click:",
		GUDSFGBUTTONTOOLTIP6 = "manage profiles.",
		GUDSFGBUTTONTOOLTIP7 = "Shift+Left-click:",
		GUDSFGBUTTONTOOLTIP8 = "move buttons.",
		STATUS = "Status: %s",
		NOKEYWORD = "No keywords!",
		INGROUP = "You are in a group, the search is stopped!",
		FINDSTOP = "The search group stopped.",
		GROUPCOUNT = "The number of groups in the search: %s",
		PROFILES = "Profiles",
		PROFILELOADED = "SGF: Profile: %s loaded.",
		PROFILESAVE = "SGF: Profile: %s saved.",
		PROFILEDELETE = "SGF: Profile: %s has been removed.",
		PROFILELOAD = "Load",
		WARNDELPROFILE = "To remove the profile, hold the Shift key!",
	},
};

function GudSmartLFG_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("VARIABLES_LOADED");
	self:SetScript("OnEvent",function(self,event,...) EVENT[event](self,...); end);
end

local function LFG_FIND_RESULT(self,text)
	local text = lower(text);
	local pattern = {strsplit("|",lower(DB.Pattern))};

	for _,str in pairs(pattern) do
		if (str ~= "" and text:find(str)) then
			local exit = false;
			if DB.PatternNo ~= "" then
				local patternno = {strsplit("|",lower(DB.PatternNo))};
				for _,exclude in pairs(patternno) do
					if (exclude ~= "" and text:find(exclude)) then
						exit = true;
					end
				end
			end
			if not exit then
				return true;
			end
		end
	end
	return;
end

local BL = {};

local function IsWorks(self)
	if DB.Pattern == "" then
		self.run = false;
		self.Log:SetFormattedText(l.STATUS,RED_COLOR..l.NOKEYWORD);
		return;
	end
	if IsInGroup() and not UnitIsGroupLeader("player") then
		self.run = false;
		self.Log:SetFormattedText(l.STATUS,YELLOW_COLOR..l.INGROUP);
		return;
	end
	if not self.run then
		self.Log:SetFormattedText(l.STATUS,RED_COLOR..l.FINDSTOP);
		return;
	end
	return true;
end

local function ApplyGroup(self,id)
	PlaySoundKitID(51324);
	if not DB.TestMode then
		local tank,heal,dd = GetAvailableRoles();
		if (tank and DB.RoleTank) or (heal and DB.RoleHealer) or (dd and DB.RoleDPS) then
			ApplyToGroup(id,"",tank and DB.RoleTank,heal and DB.RoleHealer,dd and DB.RoleDPS);
		else
			ApplyToGroup(id,"",tank,heal,dd);
		end
	end
	tempID = id;
	self.run = false;
end

local function RESULTSCHECK(self,resultID)
	local id,appStatus,pendingStatus,appDuration,role = GetApplicationInfo(resultID);
	if ((appStatus ~= "none") or pendingStatus) then return; end
	local id,activityID,name,comment,voiceChat,iLvl,honorLevel,age,numBNetFriends,numCharFriends,numGuildMates,isDelisted,leaderName,numMembers,autoInv = GetSearchResultInfo(resultID);
	local fullName, shortName, categoryID, groupID, iLevel, filters, minLevel, maxPlayers, displayType, orderIndex, useHonorLevel = C_LFGList.GetActivityInfo(activityID);
	
	if isDelisted or (not age) or (not name) or (not leaderName) or (not numMembers or (numMembers ~= 0 and numMembers < DB.MinPlayers)) or (numMembers > 35) or (DB.AutoInvGroup and (not autoInv)) then return; end
	
	if not leaderName or BL[leaderName] then return; end
	
	if DB.CrossRealmMode then
		self.GroupCount:SetFormattedText(ORANGE_COLOR..""..LFG_LIST_APPLYING_TO, name);
		print(format(ORANGE_COLOR.."SGF: "..LFG_LIST_APPLYING_TO, name));
		BL[leaderName] = id;
		ApplyGroup(self,id);
		return true;
	end
	
	if LFG_FIND_RESULT(self,name) and (age < DB.TimeAge or DB.TimeAge == 0) then
		self.GroupCount:SetFormattedText(ORANGE_COLOR..""..LFG_LIST_APPLYING_TO, name);
		print(format(ORANGE_COLOR.."SGF: "..LFG_LIST_APPLYING_TO, name));
		print(format(ORANGE_COLOR.."SGF: "..LFG_LIST_TOOLTIP_AGE, SecondsToTime(age)));
		BL[leaderName] = id;
		ApplyGroup(self,id);
		return true;
	end
end

local function SGFNewSearch(self,pause)
	self.pTime = GetTime() + DB.Throttled + 2;
	if (not pause) then
		local languages = C_LFGList.GetLanguageSearchFilter();
		C_LFGList.Search(6,"",nil,nil,languages);
	else
		After(DB.Throttled,function()
			local languages = C_LFGList.GetLanguageSearchFilter();	-- {deDE = true,enUS = true,esES = true,frFR = true,ruRU = true,itIT = true,ptBR = true};
			C_LFGList.Search(6,"",nil,nil,languages);
		end);
	end
end

function EVENT.LFG_LIST_SEARCH_RESULTS_RECEIVED(self)
	if not IsWorks(self) then return; end
	local numResults,resultIDTable = GetSearchResults();
	self.GroupCount:SetFormattedText(l.GROUPCOUNT,numResults or 0);
	self.Log:SetFormattedText(l.STATUS,GREEN_COLOR..FRIENDS_FRIENDS_WAITING);
	for _,resultID in pairs(resultIDTable) do
		if RESULTSCHECK(self,resultID) then return; end
	end
	SGFNewSearch(self,true);
end

function EVENT.LFG_LIST_SEARCH_RESULT_UPDATED(self,resultID)
	if not IsWorks(self) then return; end
	RESULTSCHECK(self,resultID);
end

function EVENT.LFG_LIST_SEARCH_FAILED( self, status )
	if status == "throttled" then
		DB.Throttled = DB.Throttled + 1;
		self.Throttled:SetValue(DB.Throttled);
		
		SGFNewSearch(self,true);
		print(ORANGE_COLOR.."SGF: "..LFG_LIST_SEARCH_FAILED);
	end
end

function EVENT.LFG_LIST_APPLICATION_STATUS_UPDATED( self, id, status, oldstatus )
	if id == tempID and DB.AutoInv and ( status == "invited" ) then
		LFGListInviteDialog_Accept(LFGListInviteDialog);
	end
end

function EVENT.LFG_LIST_JOINED_GROUP( self, id )
	if id == tempID then
		LFGListInviteDialog_Acknowledge(LFGListInviteDialog);
	end
end

local function UpdateFrames(name)
	local self = _G[DB.SELF];
	if name and DB.PF[name] then
		local TAB = DB.PF[name];
		DB.AutoInv			= TAB[1];
		DB.AutoInvGroup		= TAB[2];
		DB.Pattern			= TAB[3]	or "dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник";
		DB.PatternNo		= TAB[4]	or "camp||farm||not up";
		DB.TestMode			= TAB[5];
		DB.Throttled		= TAB[6]	or 5;
		DB.TimeAge			= TAB[7]	or 6;
		DB.CrossRealmMode	= TAB[8];
		DB.MinPlayers		= TAB[9]	or 0;
		DB.RoleTank			= TAB[10];
		DB.RoleHealer		= TAB[11];
		DB.RoleDPS			= TAB[12];
		print(format(ORANGE_COLOR..l.PROFILELOADED.."|r",HIGHLIGHT_FONT_COLOR_CODE..name..ORANGE_COLOR));
		self.GroupCount:SetFormattedText(ORANGE_COLOR..l.PROFILELOADED.."|r",HIGHLIGHT_FONT_COLOR_CODE..name..ORANGE_COLOR);
	end
	self.AutoInv:SetChecked(DB.AutoInv);
	self.AutoInvGroup:SetChecked(DB.AutoInvGroup);
	self.PatternNo:SetText(DB.PatternNo);
	self.TimeAge:SetText(DB.TimeAge);
	self.Pattern:SetText(DB.Pattern);
	self.Throttled:SetValue(DB.Throttled);
	self.TestMode:SetChecked(DB.TestMode);
	self.CrossRealmMode:SetChecked(DB.CrossRealmMode);
	self.MinPlayers:SetText(DB.MinPlayers);
	self.RoleTank:SetChecked(DB.RoleTank);
	self.RoleHealer:SetChecked(DB.RoleHealer);
	self.RoleDPS:SetChecked(DB.RoleDPS);
	if SmartGroupFinderDB.ShowTooltip then
		self.Help.Icon:SetAlpha(1);
	else
		self.Help.Icon:SetAlpha(.3);
	end
	
	local tank,heal,dd = GetAvailableRoles();
	if not tank then
		self.RoleTank.LockedIndicator:Show();
		self.RoleTank:Disable();
	end
	if not heal then
		self.RoleHealer.LockedIndicator:Show();
		self.RoleHealer:Disable();
	end
	if not dd then
		self.RoleDPS.LockedIndicator:Show();
		self.RoleDPS:Disable();
	end
end

local function PopupCreate()
	StaticPopupDialogs["EXAMPLE_HELLOWORLD"] = {
		text = "Profile",
		button1 = CREATE_NEW_COMPACT_UNIT_FRAME_PROFILE,
		button2 = DELETE,
		button3 = l.PROFILELOAD,
		OnAccept = function(self)
			ClearCursor();
			local text = self.editBox:GetText();
			DB.PF[text] = {DB.AutoInv,DB.AutoInvGroup,DB.Pattern,DB.PatternNo,DB.TestMode,DB.Throttled,DB.TimeAge,DB.CrossRealmMode,DB.MinPlayers,DB.RoleTank,DB.RoleHealer,DB.RoleDPS};
			print(format(ORANGE_COLOR..l.PROFILESAVE.."|r",HIGHLIGHT_FONT_COLOR_CODE..text..ORANGE_COLOR));
			_G[DB.SELF].GroupCount:SetFormattedText(ORANGE_COLOR..l.PROFILESAVE.."|r",HIGHLIGHT_FONT_COLOR_CODE..text..ORANGE_COLOR);
		end,
		OnAlt = function(self)
			ClearCursor();
			local text = self.editBox:GetText();
			UpdateFrames(text);
		end,
		OnCancel = function(self)
			if IsShiftKeyDown() then
				ClearCursor();
				local text = self.editBox:GetText();
				DB.PF[text] = nil;
				print(format(ORANGE_COLOR..l.PROFILEDELETE.."|r",HIGHLIGHT_FONT_COLOR_CODE..text..ORANGE_COLOR));
				_G[DB.SELF].GroupCount:SetFormattedText(ORANGE_COLOR..l.PROFILEDELETE.."|r",HIGHLIGHT_FONT_COLOR_CODE..text..ORANGE_COLOR);
			else
				print(format(ORANGE_COLOR.."SGF: %s", RED_COLOR..l.WARNDELPROFILE));
				_G[DB.SELF].GroupCount:SetFormattedText(ORANGE_COLOR.."SGF: %s", RED_COLOR..l.WARNDELPROFILE);
			end
		end,
		timeout = 0,
		whileDead = 1,
		exclusive = 1,
		-- showAlert = 1,
		hideOnEscape = 1,
		hasEditBox = 1,
		maxLetters = 32,
		OnShow = function(self)
			local t = l.PROFILES.."\n"..GREEN_COLOR;
			if next(DB.PF) then
				for i,v in pairs(DB.PF) do
					t = t..i.."\n"
				end
			else
				t = ORANGE_COLOR.."SGF: Not Profiles.";
			end
			self.text:SetJustifyH("LEFT");
			self.text:SetText(t);
			self.button1:Disable();
			self.button2:Disable();
			self.button3:Disable();
		end,
		OnHide = function(self)
			self.editBox:SetText("");
			self.text:SetJustifyH("CENTER");
		end,
		EditBoxOnEnterPressed = function(self)
			if ( self:GetParent().button1:IsEnabled() ) then
				self:GetParent():Hide();
			end
		end,
		EditBoxOnTextChanged = function (self)
			local parent = self:GetParent();
			local text = parent.editBox:GetText();
			if ( DB.PF[text] ) then
				parent.button1:Disable();
				parent.button2:Enable();
				parent.button3:Enable();
			else
				if strlenutf8(text) > 0 then
					parent.button1:Enable();
				else
					parent.button1:Disable();
				end
				parent.button2:Disable();
				parent.button3:Disable();
			end
		end,
		EditBoxOnEscapePressed = function(self)
			self:GetParent():Hide();
			ClearCursor();
		end
	};
end

function EVENT.VARIABLES_LOADED(self)
	self:UnregisterEvent("VARIABLES_LOADED");
	-- SmartGroupFinderDB = nil;
	SmartGroupFinderDB = SmartGroupFinderDB or {
		AutoInv = false,
		AutoInvGroup = true,
		Pattern = "dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник",
		PatternNo = "camp||farm||not up",
		TestMode = true,
		Throttled = 5,
		TimeAge = 6,
		CrossRealmMode = false,
		PF = {
			["ml"]={true,true,"terr||doom||death||veng","camp||farm||not up",false,3,5,false,0,true,true,true},
			["toy"]={true,true,"dreadlord||dread infiltrator||dread||doomsayer||toy||игрушка||вестник","camp||farm||not up",false,3,5,false,0,true,true,true}
		};
		SELF = self:GetName();
		MinPlayers = 0,
		RoleTank = true,
		RoleHealer = true,
		RoleDPS = true,
		ButtonPoint = {"CENTER"},
		FramePoint = {"LEFT"},
		ShowTooltip = true,
	};
	DB = SmartGroupFinderDB;
	local locale = GetLocale();
	if locale and L[locale] then
		l = L[locale];
	else
		l = L["enGB"];
	end
	L = nil;
	
	self.AutoInv.Text:SetText(l.AUTOINV);
	self.AutoInvGroup.Text:SetText(l.AUTOINVGROUP);
	self.CrossRealmMode.Text:SetText(l.CROSSREALMMODE);
	self.GroupCount:SetText("");
	self.Log:SetFormattedText(l.STATUS,RED_COLOR..l.FINDSTOP);
	self.StartStop:SetText(SLASH_STOPWATCH_PARAM_PLAY1);
	self.TestMode.Text:SetText(l.TESTMODETOOLTIP);
	self.Throttled:SetObeyStepOnDrag(true);
	self.Throttled:SetValueStep(1);
	self.Throttled.Name:SetText(l.REFRESHRATE);
	-------------------------------------
	self.AutoInv.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.AUTOINV,l.AUTOINVHELP,l.AUTOINVHELPWARN);
	self.AutoInvGroup.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.AUTOINVGROUP,l.AUTOINVGROUPHELP,l.AUTOINVGROUPHELPWARN);
	self.CrossRealmMode.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.CROSSREALMMODE,l.CROSSREALMMODEHELP,l.CROSSREALMMODEHELPWARN);
	self.Help.Tooltip = format(BATTLENET_COLOR.."%s\n%s|r %s\n"..BATTLENET_COLOR.."%s|r %s",l.HELPTOOLTIP,l.HELPTOOLTIPHELP1,l.HELPTOOLTIPHELP2,l.HELPTOOLTIPHELP3,l.HELPTOOLTIPHELP4);
	self.MinPlayers.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.MINPLAYERS,l.MINPLAYERSHELP,l.MINPLAYERSHELPWARN);
	self.Pattern.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..RED_COLOR.."%s|r",l.STRINGFIND,l.STRINGFINDHELP,l.STRINGFINDHELPWARN);
	self.PatternNo.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.STRINGEXCLUDE,l.STRINGEXCLUDEHELP,l.STRINGEXCLUDEHELPWARN);
	self.TestMode.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.TESTMODETOOLTIP,l.TESTMODETOOLTIPHELP,l.TESTMODETOOLTIPHELPWARN);
	self.Throttled.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.REFRESHRATE,l.REFRESHRATEHELP,EMPTY);
	self.TimeAge.Tooltip = format(BATTLENET_COLOR.."%s|r\n%s\n"..YELLOW_COLOR.."%s|r",l.AGEMAKEGROUP,l.AGEMAKEGROUPHELP,l.AGEMAKEGROUPHELPWARN);
	-------------------------------------
	self:SetPoint(unpack( DB.FramePoint ));
	GudSFGButton:SetPoint(unpack( DB.ButtonPoint ));
	GudSFGButton.Tooltip = format(BATTLENET_COLOR.."%s|r %s\n"..BATTLENET_COLOR.."%s|r %s\n"..BATTLENET_COLOR.."%s|r %s\n"..BATTLENET_COLOR.."%s|r %s\n",l.GUDSFGBUTTONTOOLTIP1,l.GUDSFGBUTTONTOOLTIP2,l.GUDSFGBUTTONTOOLTIP3,l.GUDSFGBUTTONTOOLTIP4,l.GUDSFGBUTTONTOOLTIP5,l.GUDSFGBUTTONTOOLTIP6,l.GUDSFGBUTTONTOOLTIP7,l.GUDSFGBUTTONTOOLTIP8);
	UpdateFrames();
	PopupCreate();
end

function EVENT.PLAYER_ENTERING_WORLD(self)
	self:UnregisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("LFG_LIST_SEARCH_RESULTS_RECEIVED");
	self:RegisterEvent("LFG_LIST_SEARCH_RESULT_UPDATED");
	self:RegisterEvent("LFG_LIST_APPLICATION_STATUS_UPDATED");
	self:RegisterEvent("LFG_LIST_SEARCH_FAILED");
	self:RegisterEvent("LFG_LIST_JOINED_GROUP");
end

function SGFButtonUpdate(self,elapsed)
	local self = _G[SmartGroupFinderDB.SELF];
	if not self.run and self.pTime and (self.pTime > GetTime()) then
		self.StartStop:Disable();
		self.StartStop:SetText(ON_COOLDOWN);
		self.StartStop:SetBackdropColor(.2,.2,.2);
		GudSFGButton:Disable();
		GudSFGButton.Eye:Hide();
		return;
	else
		self.StartStop:Enable();
		GudSFGButton:Enable();
	end
	if IsInGroup() then
		self.StartStop:SetBackdropColor(1,1,0);
		self.StartStop:SetText(PARTY_LEAVE);
		return
	end
	if self.run then
		GudSFGButton.Eye:Show();
		self.StartStop:SetBackdropColor(1,.2,.2);
		self.StartStop:SetText(SLASH_STOPWATCH_PARAM_STOP1);
	else
		GudSFGButton.Eye:Hide();
		self.StartStop:SetBackdropColor(0,1,0);
		self.StartStop:SetText(LFG_LIST_SEARCH_AGAIN);
	end
end

function SGFButtonStart(self,button)
	if button == "LeftButton" then
		PlaySound("igMainMenuOptionCheckBoxOn");
		if IsInGroup() then
			LeaveParty();
			return;
		end
		local self = _G[SmartGroupFinderDB.SELF];
		if self.run then
			self.run = not self.run;
			return
		end
		if self.pTime and (self.pTime > GetTime()) then return; end
		self.run = not self.run;
		if self.run then
			SGFNewSearch(self);
		end
	elseif button == "RightButton" then
		local self = _G[SmartGroupFinderDB.SELF];
		if self:IsVisible() then
			self:Hide();
		else
			self:Show();
		end
	elseif button == "MiddleButton" then
		local _, dialog = StaticPopup_Visible("EXAMPLE_HELLOWORLD");
		if dialog then
			StaticPopup_Hide("EXAMPLE_HELLOWORLD");
		else
			StaticPopup_Show("EXAMPLE_HELLOWORLD");
		end
	end
	PlaySound("igMainMenuOptionCheckBoxOn");
end

SLASH_GUDPROFILESAVE1 = "/sgf"
SLASH_GUDPROFILESAVE1 = "/SGF"
SlashCmdList.GUDPROFILESAVE = function(msg)
	local com = gsub(msg, "%s*([^%s]+).*", "%1");
	local name = gsub(msg, "%s*([^%s]+)%s*(.*)", "%2");
	if com == "list" then
		if next(DB.PF) then
			for i,v in pairs(DB.PF) do
				print(ORANGE_COLOR.."SGF: --- --- ---|r");
				print(ORANGE_COLOR.."SGF: Profile: "..YELLOW_COLOR.."" .. i .."|r");
				print(ORANGE_COLOR.."SGF: Keywords: "..YELLOW_COLOR.."" .. v[3].."|r");
			end
		else
			print(ORANGE_COLOR.."SGF: Not Profiles.");
		end
		return;
	end
	if name ~= "" and com ~= "" then
		if com == "sp" then
			DB.PF[name] = {DB.AutoInv,DB.AutoInvGroup,DB.Pattern,DB.PatternNo,DB.TestMode,DB.Throttled,DB.TimeAge,DB.CrossRealmMode,DB.MinPlayers,DB.RoleTank,DB.RoleHealer,DB.RoleDPS};
			print(ORANGE_COLOR.."SGF: Save Profile: |r",name);
		elseif com == "dp" then
			if DB.PF[name] then
				DB.PF[name] = nil;
				print(ORANGE_COLOR.."SGF: Delete Profile: |r",name);
			end
		elseif com == "lp" then
			UpdateFrames(name);
		end
	end
end